/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.records.TInputLanguageRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputLanguage extends TableImpl<TInputLanguageRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_language</code>
     */
    public static final TInputLanguage T_INPUT_LANGUAGE = new TInputLanguage();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputLanguageRecord> getRecordType() {
        return TInputLanguageRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_language.pk_input_language</code>.
     */
    public final TableField<TInputLanguageRecord, Integer> PK_INPUT_LANGUAGE = createField(DSL.name("pk_input_language"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_input_language.lang_isocode</code>. language
     * iso code
     */
    public final TableField<TInputLanguageRecord, String> LANG_ISOCODE = createField(DSL.name("lang_isocode"), SQLDataType.CLOB.nullable(false), this, "language iso code");

    /**
     * The column <code>common_dd.t_input_language.appl_name</code>. application
     * name
     */
    public final TableField<TInputLanguageRecord, String> APPL_NAME = createField(DSL.name("appl_name"), SQLDataType.CLOB.nullable(false), this, "application name");

    /**
     * The column <code>common_dd.t_input_language.lastchange</code>.
     */
    public final TableField<TInputLanguageRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TInputLanguage(Name alias, Table<TInputLanguageRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputLanguage(Name alias, Table<TInputLanguageRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_language</code> table reference
     */
    public TInputLanguage(String alias) {
        this(DSL.name(alias), T_INPUT_LANGUAGE);
    }

    /**
     * Create an aliased <code>common_dd.t_input_language</code> table reference
     */
    public TInputLanguage(Name alias) {
        this(alias, T_INPUT_LANGUAGE);
    }

    /**
     * Create a <code>common_dd.t_input_language</code> table reference
     */
    public TInputLanguage() {
        this(DSL.name("t_input_language"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TInputLanguageRecord, Integer> getIdentity() {
        return (Identity<TInputLanguageRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputLanguageRecord> getPrimaryKey() {
        return Keys.PK_INPUT_LANGUAGE;
    }

    @Override
    public List<UniqueKey<TInputLanguageRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_APPL_ISOCODE);
    }

    @Override
    public TInputLanguage as(String alias) {
        return new TInputLanguage(DSL.name(alias), this);
    }

    @Override
    public TInputLanguage as(Name alias) {
        return new TInputLanguage(alias, this);
    }

    @Override
    public TInputLanguage as(Table<?> alias) {
        return new TInputLanguage(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputLanguage rename(String name) {
        return new TInputLanguage(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputLanguage rename(Name name) {
        return new TInputLanguage(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputLanguage rename(Table<?> name) {
        return new TInputLanguage(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLanguage where(Condition condition) {
        return new TInputLanguage(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLanguage where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLanguage where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLanguage where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputLanguage where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputLanguage where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputLanguage where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputLanguage where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLanguage whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLanguage whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
